%% Script to analyze 405-normalized data based on whole trace (not baseline only)
% First open file that you have previously analysed with
% FP_IP_drug_response_basic_analysis1

%downsample 10x to decrease filesizes:
data_ds_normalized_original = downsample(data_norm.data,10); %downsample output
sample_freq = data_norm.samplerate./10; %sampling frequency 

%% create output averages per 30s for excel
%bin the data to 30s periods
[binned_0to20_normalized_original,binned_0to20_last_normalized_original] = FP_Average_to_bins(data_ds_normalized_original(round((ts_post).*sample_freq) : round((ts_post+2000).*sample_freq)), sample_freq, 30);
[binned_min5to0_normalized_original,binned_min5to0_last_normalized_original] = FP_Average_to_bins(data_ds_normalized_original(round((ts_pre-301).*sample_freq) : round((ts_pre).*sample_freq)), sample_freq, 30);

%% plot the raw data trace
%plot data
figure;
plot(data_ds_normalized_original);

%modify axes
xlim([round((ts_post-300).*sample_freq) round((ts_post+2000).*sample_freq)]);
ylim([-0.05 0.25]);
ax = gca;
ax.XTick=([round((ts_post-300).*sample_freq) : round(300.*sample_freq) : round((ts_post+2000).*sample_freq)]);
ax.XTickLabel={'-5', '0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50'};

%standardize figure size
fig = gcf;
fig.Position = [186   349   566   264];

%draw lines at Y = 0 and X = 0, removes box, and adds title
line([ts_post.*sample_freq ts_post.*sample_freq], [-0.1 0.35], 'color' ,'r');
getxlim = xlim;
line([getxlim(1) getxlim(2)],[0 0], 'color' ,'k');
box off;
note_title =  strcat(file,'-',note_condition); 
title(note_title);



%% saves the data
% matlab file
save(strcat(note_title, '-ORIGINAL_405_norm', '.mat'));

% figure as pdf
saveas(fig,strcat(note_title, '-ORIGINAL_405_norm'), 'pdf');