function dopt = mkspecgramdrawopt(varargin)
% MKCONTDRAWOPT make display structure for contstructs
%
% $$$      -shading - see 'help shading': 'interp', ('flat'), 'faceted'
% $$$                 careful, 'interp' is pretty but slow
% $$$      -logfreq - boolean, use log frequency axis
% $$$      -ncycleline - draw dotted line at n cycles/window frequency
% $$$      -freqrange - to display; all up to nyquist calc'd regardless
% $$$      -datalim - range of data to scale to colormap (default: scale to full range)
% $$$      -dispname - name to be displayed (use params?)
% $$$
% $$$      -cmap - colormap to be used
% $$$      -cmapwin - indexes of start and end of colormap region to use ([] = use all)

  dopt = struct(...  
      'dispname', [],...
      'shading', 'flat',...
      'logfreq', false,...
      'ncycleline', 1,... 
      'freqrange', [],...
      'datalim', [],...
      'cmap', jet(64),...
      'cmapwin',[]);

  dopt = parseArgsLite(varargin,dopt);