function cdisp = slmkspecdisp(varargin)
% SLMKSPECDISP mk display structure for spectrograms in spikeslpos
%
% $$$    -specgram
% $$$      -contdata
% $$$      -contvar - name of the contdata to use
% $$$      -sgopt
% $$$        -method ('multitaper', 'specgram'-matlab defaults, i.e. hanning window)
% $$$        -nfft
% $$$        -window
% $$$        -noverlap
% $$$        -mt_NW - multitaper param
% $$$        -mt_detrend ([], or 'constant') 
% $$$
% $$$      [display options]
% $$$      -disp (height, yflip, ...)
% $$$      -logfreq - boolean
% $$$      -freqrange - to display, all up to nyquist calcd
% $$$      -dispname - name to be displayed (use params?)
%
% use contdata struct, see slmkcont
  
% todo
% check window/fft/noverlap length, etc here
  
  a = struct(...
      'disp' , slmkdisp,...
      'contdata', [],... % contdata struct to use
      'contvar', [],... % name of contdata variable in base workspace
      'dispname', [],...
        ...
      'method','specgram',...
        ...
      'nfft',512,...
      'window',500,...
      'noverlap',250,...
      'mt_NW', 2,...
      'mt_detrend', [],...
        ...
      'shading', 'flat',...
      'logfreq', false,...
      'logf_bpo',12,...
      'freqrange', []);
  
  a = parseArgs(varargin,a);
  
  cdisp = struct(...
      'contdata', a.contdata,...
      'contvar', a.contvar,...
      'dispname', a.dispname,...
      'method', a.method,...
      'nfft', a.nfft,...
      'window', a.window,...
      'noverlap', a.noverlap,...
      'mt_NW', a.mt_NW,...
      'mt_detrend', a.mt_detrend,...
      'shading', a.shading,...
      'logfreq', a.logfreq,...
      'logf_bpo', a.logf_bpo,...
      'freqrange',a.freqrange);
  
  