function [Final Raw c_Regress bls YFit] = FP_Control(filepath, tank, blk, control_LP_F)
% Runs all the other analysis programs- Written by Ruud
% Assumes data formats used on RZ5P from TDT with FP set up
%  INPUTS
%    filepath: folder where tank is stored
%    tank: tank name
%    blk: block name
%
% Example
% filepath = 'C:\Users\Ruud\Tanks'
% tank = 'test1-161005-164443'
% blk = 'test1-161025-094019'

S = TDT_Import(filepath, tank, blk, '470A', 1);
C = TDT_Import(filepath, tank, blk, '405A', 1);

Raw = [S C];

%this parts reconstructs & combines the structrues S&C so they can be used
%by the normalization function

comb = [S]; %builds the combined structure of the 470 signal data
comb.data = [S.data C.data]; %adds the control signal to the data tree
comb.units = 'mV' ; %adds a unit scale 
comb.chanlabels = {'470nm','405nm'};; %adds chanlabels
comb.samplerate = comb.sampling_rate ;%different naming conventions
comb.chanvals = [NaN, NaN]%i dont understand the function of this
comb.nbad_start = 0%i dont understand the function of this
comb.nbad_end = 0%i dont understand the function of this
comb.name = blk %this is just the name within the new function
comb.datarange = [min(comb.data(:,1)), max(comb.data(:,1));min(comb.data(:,2)), max(comb.data(:,2)) ] %this is likely correct but not 100% sure
comb.max_tserr =  comb.max_ts_err %different naming conventions
comb.mean_tserr=   0 %this was copied from a different data set and I have no idea what it means (timestamp error?)

[Final c_Regress bls YFit] = FP_normalize_RVZ(comb, ...
'norm_type', 'fit' ,...
'control_LP_F', [0.1 0.2], ...
'rig_baseline_V', [],...
'dFF_zero_prctile', []);
end
